# class ActionDispatch::RequestId

Makes a unique request id available to the action_dispatch.request_id env variable (which is then accessible through ActionDispatch::Request#uuid) and sends the same id to the client via the X-Request-Id header.

The unique request id is either based off the X-Request-Id header in the request, which would typically be generated by a firewall, load balancer, or the web server, or, if this header is not available, a random uuid. If the header is accepted from the outside world, we sanitize it to a max of 255 chars and alphanumeric and dashes only.

The unique request id can be used to trace a request end-to-end and would typically end up being part of log files from multiple pieces of the stack.

### Public Class Methods

new(app) click to toggle source

    # File lib/action_dispatch/middleware/request_id.rb, line 16
    def initialize(app)
      @app = app
    end

### Public Instance Methods

call(env) click to toggle source

    # File lib/action_dispatch/middleware/request_id.rb, line 20
    def call(env)
      env["action_dispatch.request_id"] = external_request_id(env) || internal_request_id
      status, headers, body = @app.call(env)

      headers["X-Request-Id"] = env["action_dispatch.request_id"]
      [ status, headers, body ]
    end